Attribute VB_Name = "modGlobal"
'=================================================================================
'//
'//               File Protection Project
'//             Author: Huang Guan
'//             Email : gdxxhg@gmail.com
'//             Desc  :
'//
'//
'=================================================================================

Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

'For P2S
Private Declare Function lstrlen Lib "kernel32" Alias "lstrlenA" (ByVal lpString As Long) As Long
Private Declare Function lstrcpy Lib "kernel32" Alias "lstrcpyA" (ByVal lpBuffer As String, ByVal lpString As Long) As Long

'Polling message
Public lWarnResult  As Long, bTermProcess As Boolean

'Protection Range
Public Const PR_NONE = 0
Public Const PR_SELF = 1
Public Const PR_DIRECT = 2
Public Const PR_ALL = 3

'Protection Flag
Public Const PF_EXEONLY = 1
Public Const PF_SYSOK = 2
Public Const PF_PASSWORD = 4
Public Const PF_QUIET = 8

Public Type ProtListItemType
    Path As String * 1024
    ProtRange As Long
    ProtFlag As Long
    Password(15) As Byte
End Type

Public ProtList() As ProtListItemType
Public ProtListCount As Long
Public ProtListFile As String
Public Const MaxProtListItem = 1024

Public Type ProcListItemType
    Path As String * 1024
End Type
Public ProcList() As ProcListItemType
Public ProcListCount As Long
Public ProcListFile As String
Public Const MaxProcListItem = 1024

'״̬
'1   0 ر
Public ProtStatus As Integer
Public bytPassword(15) As Byte


'úڰCַָתΪVBString
Public Function P2S(ByVal lPointer As Long) As String
    Dim sRet As String, lRet As Long
    sRet = String$(lstrlen(ByVal lPointer), 0)                      'Run-time error '53': File not found:
    lRet = lstrcpy(ByVal sRet, ByVal lPointer)
    If lRet Then P2S = sRet Else P2S = ""
End Function

Public Sub StartProtection()
    Dim lRet As Long
    lRet = modSystem.do_status(2)
    If lRet < 0 Then
        MsgBox "״̬ʧܡ", vbCritical
        Exit Sub
    End If
    lRet = modSystem.do_make_thread()
    If lRet < 0 Then
        MsgBox "߳ʧܡ", vbCritical
        Exit Sub
    End If
    SetProctectionStatus 1
    frmControl.tmrPoll.Enabled = True
End Sub

Public Sub StopProtection()
    Dim lRet As Long
    frmControl.tmrPoll.Enabled = False
    
    lRet = modSystem.do_status(1)
    If lRet < 0 Then
        MsgBox "״̬ʧܡ", vbCritical
        Exit Sub
    End If
    lRet = modSystem.do_quit_thread()
    If lRet < 0 Then
        MsgBox "ر߳ʧܡ", vbCritical
        Exit Sub
    End If
    SetProctectionStatus 0
End Sub

Public Sub SetProctectionStatus(status As Integer)
    ProtStatus = status
    If status = 1 Then
        frmControl.cmdOpenClose.Caption = "ر"
        frmControl.lbStatus.Caption = ""
    Else
        frmControl.cmdOpenClose.Caption = ""
        frmControl.lbStatus.Caption = "ر"
    End If
End Sub

Private Function MatchName(str1 As String, str2 As String) As Integer
    Dim matched As Integer, i As Integer
    matched = 0
    For i = 1 To Len(str2)
        If i <= Len(str1) Then
            If LCase(Mid(str1, i, 1)) = LCase(Mid(str2, i, 1)) Then
                matched = matched + 1
            End If
        End If
    Next
    MatchName = matched
End Function

Public Sub PollMessage()
On Error Resume Next
    Dim lRet As Long, lProc As Long, lFile As Long
    Dim procName As String, fileName As String
    lRet = modSystem.do_poll_msg(lProc, lFile)
    If lRet = 1 Then
        procName = P2S(ByVal lProc)
        fileName = P2S(ByVal lFile)
        lWarnResult = 0
        frmWarning.lbMsg = " " & procName & " ͼдܱļ " & fileName
        frmWarning.LoadIcon procName
        bTermProcess = False
        frmWarning.strProc = procName
        frmWarning.strFileName = fileName
        If Mid(fileName, Len(fileName), 1) = "*" Then
            Dim i As Integer, m As Integer, max As Integer, mi As Integer
            mi = -1
            fileName = Left(fileName, Len(fileName) - 1)
            For i = 0 To ProtListCount - 1
                If (ProtList(i).ProtFlag And PF_PASSWORD) = PF_PASSWORD Then
                    m = MatchName(fileName, ProtList(i).Path)
                    If m > max Then
                        max = m
                        mi = i
                    End If
                End If
            Next
            If mi <> -1 Then
                For i = 0 To 15
                    bytPassword(i) = ProtList(mi).Password(i)
                Next
            End If
            
            frmWarning.txtPassword.Text = ""
            frmWarning.framePassword.Visible = True
        Else
            frmWarning.framePassword.Visible = False
        End If
        frmWarning.Show 1
        lRet = modSystem.do_put_result(lWarnResult)
        If bTermProcess = True Then
            modProcess.KillProcess GetProcessName(procName), True
        End If
    ElseIf lRet = -1 Then
        MsgBox "߳Ѿ˳"
        StopProtection
    End If
End Sub

'
Public Sub Main()
    On Error Resume Next
    Dim i As Integer
    App.TaskVisible = False
    
    Dim lRet As Long, lpName As String, lpFile As String
    lpName = String$(256, 0)
    lpFile = String$(1024, 0)
    lpName = "fsdriver"
    lpFile = "fsdriver.sys"
    
    '
    'Do something initialization
    '
    ReDim ProtList(MaxProtListItem) As ProtListItemType
    ReDim ProcList(MaxProcListItem) As ProcListItemType
    ProtListFile = App.Path & "\protlist.dat"
    ProcListFile = App.Path & "\proclist.dat"
    LoadProcListFromFile ProcListFile
    LoadProtListFromFile ProtListFile
    
    
    'Load Driver
    lRet = modSystem.do_load(ByVal lpName, ByVal lpFile)
    If lRet < 0 Then
        Sleep 10000
        Shell "cmd.exe /C start " & Chr(34) & App.Path & "\" & App.EXEName & ".exe" & Chr(34)
        'MsgBox "ʧܡ", vbCritical
        End
    End If
    
    Sleep 1000
    
    'check app
    If App.PrevInstance Then
        MsgBox "Ѿһļ档", vbExclamation
        End
    End If
    
    'Init System
    lRet = modSystem.do_init
    If lRet < 0 Then
        MsgBox "ϵͳʼʧܣǷȷء"
        End
    End If
    
    'write list to the driver
    WriteList
    WriteProc
    
    'Load Forms
    load frmControl
    load frmWarning
    load frmAddCur
    
    'check status
    Dim status As String
    status = GetSetting("FileProtection", "Setting", "Protection", "true")
    If status = "true" Then
        StartProtection
    End If
End Sub

Public Sub ExitProgram()
    Dim lRet As Long, lpName As String, lpFile As String
    lpName = String$(256, 0)
    lpFile = String$(1024, 0)
    lpName = "fsdriver"
    lpFile = "fsdriver.sys"
    
    If ProtStatus = 1 Then
        StopProtection
    End If
    
    modSystem.do_cleanup
    
    'Load Driver
    lRet = modSystem.do_unload(ByVal lpName, ByVal lpFile)
    If lRet < 0 Then
        MsgBox "жʧܡ", vbCritical
        End
    End If
    
End Sub


Public Sub SaveProtListToFile(fileName As String)
    Dim i As Integer
    Open fileName For Random As #1 Len = 8192
    Put #1, , ProtListCount
    For i = 0 To ProtListCount - 1
        Put #1, , ProtList(i)
    Next
    Close #1
End Sub

Public Sub LoadProtListFromFile(fileName As String)
    Dim i As Integer
    Open fileName For Random As #1 Len = 8192
    Get #1, , ProtListCount
    For i = 0 To ProtListCount - 1
        Get #1, , ProtList(i)
    Next
    Close #1
    If ProtListCount = 0 Then
        InitProtList
    End If
End Sub

Public Sub SaveProcListToFile(fileName As String)
    Dim i As Integer
    Open fileName For Random As #1 Len = 8192
    Put #1, , ProcListCount
    For i = 0 To ProcListCount - 1
        Put #1, , ProcList(i)
    Next
    Close #1
End Sub

Public Sub LoadProcListFromFile(fileName As String)
    Dim i As Integer
    Open fileName For Random As #1 Len = 8192
    Get #1, , ProcListCount
    For i = 0 To ProcListCount - 1
        Get #1, , ProcList(i)
    Next
    Close #1
    If ProcListCount = 0 Then
        InitProcList
    End If
End Sub

'ʼб
Public Sub InitProcList()
    With ProcList(0)
        .Path = "C:\Windows\"
    End With
    ProcListCount = 1
    SaveProcListToFile ProcListFile
End Sub

'ʼб
Public Sub InitProtList()
    With ProtList(0)
        .Path = "C:\Windows"
        .ProtRange = PR_ALL
        .ProtFlag = PF_SYSOK
    End With
    With ProtList(1)
        .Path = "C:"
        .ProtRange = PR_ALL
        .ProtFlag = PF_EXEONLY + PF_SYSOK
    End With
    With ProtList(2)
        .Path = "C:\Recycled"
        .ProtRange = PR_NONE
        .ProtFlag = 0
    End With
    ProtListCount = 3
    SaveProtListToFile ProtListFile
End Sub

'ñб
Public Sub WriteList()
    Dim lRet As Long, i As Long, lpPath As String
    modSystem.do_fn_clean
    For i = 0 To ProtListCount - 1
        With ProtList(i)
            lpPath = Trim(.Path)
            modSystem.do_fn_add ByVal lpPath, ByVal .ProtRange, ByVal .ProtFlag
        End With
    Next
    lRet = modSystem.do_fn_write()
    If lRet < 0 Then
        MsgBox "±бʧܡ", vbCritical
    End If
End Sub

'Ȩб
Public Sub WriteProc()
    Dim lRet As Long, i As Long, lpPath As String
    modSystem.do_sysproc_clean
    For i = 0 To ProcListCount - 1
        With ProcList(i)
            lpPath = Trim(.Path)
            modSystem.do_sysproc_add ByVal lpPath
        End With
    Next
    lRet = modSystem.do_sysproc_write()
    If lRet < 0 Then
        MsgBox "Ȩбʧܡ", vbCritical
    End If
End Sub

Public Function GetProcessName(lpPath As String) As String
    Dim i As Integer, l As Integer
    i = InStrRev(lpPath, "\")
    GetProcessName = ""
    If i > 0 Then
        GetProcessName = Right(lpPath, Len(lpPath) - i)
    End If
End Function
