
#include <windows.h>
#include <winioctl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h> 
#include "load.h"

BOOLEAN
ManageDriver(
    __in LPCTSTR  DriverName,
    __in LPCTSTR  ServiceName,
    __in USHORT   Function
    );

BOOLEAN
SetupDriverName(
    __inout_bcount_full(BufferLength) PCHAR DriverLocation,
    __in ULONG BufferLength
    );

char g_DriverName[32];
char g_FileName[MAX_PATH];

int __declspec(dllexport) __stdcall load_dev( char* name, char* path )
{
    UCHAR driverLocation[MAX_PATH];
    // The driver is not started yet so let us the install the driver.
    // First setup full path to driver name.
	strncpy( g_DriverName, name, MAX_PATH );
    if( path[0]!='\\' ){
    	strcpy( g_FileName, "\\" );
		strncat( g_FileName, path, MAX_PATH-1 );
	}else{
		strncpy( g_FileName, path, MAX_PATH );
	}

    if (!SetupDriverName(driverLocation, sizeof(driverLocation))) {
			return -2;
    }
	
    if (!ManageDriver(g_DriverName,
                      driverLocation,
                      DRIVER_FUNC_INSTALL
                      )) {

        printf("Unable to install driver. \n");

        // Error - remove driver.

        ManageDriver(g_DriverName,
                     driverLocation,
                     DRIVER_FUNC_REMOVE
                     );

        return -1;
    }
    return 0;
}

int __declspec(dllexport) __stdcall unload_dev( char* name, char* path )
{
    UCHAR driverLocation[MAX_PATH];
    // The driver is not started yet so let us the install the driver.
    // First setup full path to driver name.
	strncpy( g_DriverName, name, MAX_PATH );
    if( path[0]!='\\' ){
    	strcpy( g_FileName, "\\" );
		strncat( g_FileName, path, MAX_PATH-1 );
	}else{
		strncpy( g_FileName, path, MAX_PATH );
	}

    if (!SetupDriverName(driverLocation, sizeof(driverLocation))) {
			return -2;
    }
	
    if (!ManageDriver(g_DriverName,
                      driverLocation,
                      DRIVER_FUNC_REMOVE
                      )) {

        printf("Unable to remove driver. \n");

        return -1;
    }
    return 0;
} 

int __cdecl
main(
    __in ULONG argc,
    __in_ecount(argc) PCHAR argv[]
    )
{
    HANDLE hDevice;
    BOOL bRc;
    ULONG bytesReturned;
    DWORD errNum = 0;
    UCHAR driverLocation[MAX_PATH];

	if( argc<4 ){
		printf("load load|unload DriverName  File\n");
		return -3;
	}

    //
    // The driver is not started yet so let us the install the driver.
    // First setup full path to driver name.
	strncpy( g_DriverName, argv[2], MAX_PATH );
    if( argv[3][0]!='\\' ){
    	strcpy( g_FileName, "\\" );
		strncat( g_FileName, argv[3], MAX_PATH-1 );
	}else{
		strncpy( g_FileName, argv[3], MAX_PATH );
	}

    if (!SetupDriverName(driverLocation, sizeof(driverLocation))) {
			return -2;
    }
    
    if( strcmp( argv[1], "load" )==0 )
    {
        printf("Installing driver %s\n", driverLocation );
    
        if (!ManageDriver(g_DriverName,
                          driverLocation,
                          DRIVER_FUNC_INSTALL
                          )) {
    
            printf("Unable to install driver. \n");
    
            // Error - remove driver.
    
            ManageDriver(g_DriverName,
                         driverLocation,
                         DRIVER_FUNC_REMOVE
                         );
    
            return -1;
        }
    }else if( strcmp( argv[1], "unload" )==0 ){
        // Unload the driver.  Ignore any errors.
        printf("Uninstalling driver: %s\n", g_DriverName );
        if (!ManageDriver(g_DriverName,
                     driverLocation,
                     DRIVER_FUNC_REMOVE
                     )) {
            printf("Unable to remove driver. \n");
            return -1;
        }
    }
    return 0;
}


