
//rlist_t

#ifndef _RLIST_H
#define _RLIST_H

typedef void (* remove_item ) ( int v );
typedef int (* compare_item ) ( int v1, int v2 );

//Round List
typedef struct rlist_s{
	int		head;
	int		tail;
	int		size;		//size*4 = buffer size
	remove_item	remover;
	compare_item	comparer;
	int*		list;
}rlist_t;

int rlist_init( rlist_t* l, int size, remove_item remover, compare_item comparer );
int rlist_find( rlist_t * l, int v );
int rlist_append( rlist_t* l, int v );
void rlist_cleanup( rlist_t* l );


#endif //_RLIST_H
